let $ = (sel) => document.querySelector(sel)
const rand = (min, max) => min + Math.floor(Math.random() * (max - min))
const logo = `<img src="https://static.igem.wiki/teams/5061/site-assets/logo-centre.png">`

function catAndBtn(cat) {
  return `<h1>${cat}</h1><button onclick="jarvis(pages, logo);rotateCenter()">↚ previous</button>`
}

let BASE = window.location.origin + "/evry-paris-saclay"
//if (window.location.origin !== "2024.igem.wiki") BASE = ""

const pages = {
  "description": () => window.location.href = BASE + "/description",
  "team": () => {
    jarvis({
      "members": () => window.location.href = BASE + "/team",
      "attribution": () => window.location.href = BASE + "/attributions"
    }, catAndBtn("team"))
  },
  "human practices": () => window.location.href = BASE + "/human-practices",
  "wet lab": () => {
    jarvis({
      "engineering": () => window.location.href = BASE + "/engineering",
      "parts": () => window.location.href = BASE + "/parts",
      "part collection": () => window.location.href = BASE + "/part-collection",
      "contribution": () => window.location.href = BASE + "/contribution"
    }, catAndBtn("wet lab"))
  },
  "dry lab": () => {
    jarvis({
      "software": () => window.location.href = BASE + "/software",
      "model": () => window.location.href = BASE + "/model",
      "hypertron2000": () => window.location.href = "https://www.youtube.com/watch?v=dQw4w9WgXcQ"
    }, catAndBtn("dry lab"))
  },
}

function segments(array, dict) {
  let n = array.length
  let theta = 360 / n
  let segments = $(".jarvis .segments")
  segments.innerHTML = ""

  for (let i = 0; i < n; i++) {
    const s = n <= 2 ? "height: calc(var(--size) / 2);left: 0;width: var(--size);" :
      "transform: skewX(${90 - theta}deg);";
    let segment = document.createElement('div')
    segment.className = "segment-wrapper"
    segment.innerHTML = `<div class="segment" style="${s}"></div>`
    segment.onclick = () => {
      dict[array[i]]()
    }

    segments.appendChild(segment)
    segment.style.transform = `rotate(${theta * i}deg)`
  }
}

function text(array) {
  let theta = (360 / array.length)
  let container = $(".circled-text")
  container.innerHTML = ""

  for (let i = 0; i < array.length; i++) {
    let text = array[i]
    let alpha = 0.5 * theta - (text.length * 1.7)

    container.innerHTML += `<svg style="transform: rotate(${(theta * i) + alpha}deg);" viewBox="0 0 100 100"
      xmlns="http://www.w3.org/2000/svg">
      <path class="path-circle" id="circlePath" fill="none" d="
            M 10, 50
            a 40,40 0 1,1 80,0
            a 40,40 0 1,1 -80,0
          " />
      <text class="circular-text" id="text" font-family="monospace" font-size="12" font-weight="bold" fill="white">
        <textPath id="textPath" href="#circlePath">${text}</textPath>
      </text>
    </svg>`
  }
}

function jarvis(dict, inner) {
  let array = Object.keys(dict)
  text(array)
  segments(array, dict)
  $('.jarvis .inner').innerHTML = inner
}

let smoothMove = 5
const root = document.documentElement;
smoothMove /= 100;

document.addEventListener('mousemove', (event) => {
  const rotateX = (event.clientY - window.innerHeight / 2) * smoothMove;
  const rotateY = ((event.clientX - window.innerWidth / 2) * -smoothMove) / 2;

  const amplitudeX = 90
  const amplitudeY = 50

  root.style.setProperty('--rotate-x', `${rotateX}deg`);
  root.style.setProperty('--translate-x', `${rotateY}px`);
  root.style.setProperty('--translate-y', `${rotateX}px`);
  root.style.setProperty('--rotate-y', `${rotateY}deg`);
});

function normal(x, mean, sd, maxvalue = 1, minvalue = 0) {
  function f(x, mean, sd) {
    return (1 / (sd * Math.sqrt(Math.PI * 2))) * Math.exp(-0.5 * (((x - mean) / sd) ** 2))
  }

  let res = f(x, mean, sd)
  let max = f(mean, mean, sd)
  return (res / max) * maxvalue + minvalue
}

function linkPage(i) {
  let key = Object.keys(pages)[i]
  let page = pages[key]
  page()
}

jarvis(pages, logo)